/** @file CameraManager.cpp
 *
 *  @brief CCameraManager ̎
 *
 *  @version    1.0
 *  @date       2005/5/23
 *  @author     SEC
 *
 */

#include "stdafx.h"
#include "CameraManager.h"

/**    RXgN^
 */ 
CCameraManager::CCameraManager(){
    m_pF = NULL;
    m_pGrab = NULL;
    m_pbf = NULL;
    m_pMC = NULL;
    m_pEV = NULL;       
    m_pGraph = NULL;
    m_pCapture = NULL;
    m_pBuffer_Cur = NULL;
    m_pBuffer_Pre = NULL;
    m_pImage = NULL;
    m_bInitialize = FALSE;
    m_threshold = 10;

}

/**    fXgN^
 */ 
CCameraManager::~CCameraManager(){
}

/** 
 *
 * sD
 *
 *  @retval HRESULT
 */ 
HRESULT CCameraManager::Initialize(){
    HRESULT hr;
    AM_MEDIA_TYPE   amt;   // fBA^Cv

    m_hMutex = CreateMutex(NULL,FALSE,NULL);    //~[ebNX

    // COM̏
    CoInitialize(NULL);

    //--------------------------------------
    // (1) tB^Ot}l[W쐬
    //--------------------------------------
    hr = CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC,
                     IID_IGraphBuilder, (void **)&m_pGraph);
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (2) foCXtB^̏
    //--------------------------------------
    // VXefoCX񋓎q쐬
    ICreateDevEnum *pDevEnum =NULL;
    hr = CoCreateInstance(CLSID_SystemDeviceEnum, NULL, CLSCTX_INPROC,
                     IID_ICreateDevEnum, (void **)&pDevEnum);
    if (FAILED(hr)) {
        return hr;
    }

    // rfILv`foCX񋓎q쐬
    IEnumMoniker *pClassEnum = NULL;
    pDevEnum->CreateClassEnumerator(CLSID_VideoInputDeviceCategory, &pClassEnum, 0);
    if (pClassEnum == NULL){
        // rfILv`݂͑Ȃ
        pDevEnum->Release();
        return S_FALSE;
    }

    // ŏɌrfILv`foCX̃IuWFNg
    // C^tF[X𓾂
    IMoniker *pMoniker = NULL;
    ULONG cFetched;
    if (pClassEnum->Next(1, &pMoniker, &cFetched) == S_OK) {
        pMoniker->BindToObject(0, 0, IID_IBaseFilter, (void **)&m_pbf);
        pMoniker->Release();
    }
    pClassEnum->Release();
    pDevEnum->Release();

    // foCXtB^tB^Otɒǉ
    hr = m_pGraph->AddFilter(m_pbf, L"Video Capture");
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (3) Lv`Otr_쐬
    //--------------------------------------
    CoCreateInstance(CLSID_CaptureGraphBuilder2 , NULL, CLSCTX_INPROC,
                     IID_ICaptureGraphBuilder2, (void **)&m_pCapture);
    // tB^OtLv`Otɑgݍ
    hr = m_pCapture->SetFiltergraph(m_pGraph);
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (4) TvOo쐬
    //--------------------------------------
    hr = CoCreateInstance(CLSID_SampleGrabber, NULL, CLSCTX_INPROC_SERVER, 
                     IID_IBaseFilter, (LPVOID *)&m_pF);
    if (FAILED(hr)) {
        return hr;
    }

    hr = m_pF->QueryInterface(IID_ISampleGrabber, (void **)&m_pGrab);
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (5) fBA^Cv̐ݒ
    //--------------------------------------
    // OotB^̑}ꏊ̓̂߂̐ݒ
    ZeroMemory(&amt, sizeof(AM_MEDIA_TYPE));
    amt.majortype  = MEDIATYPE_Video;   // Sample Grabber ̓̓s(Capture Device ̏o̓s)UYVY
    amt.subtype    = MEDIASUBTYPE_RGB24;
    amt.formattype = FORMAT_VideoInfo; 
    hr = m_pGrab->SetMediaType(&amt);
    if (FAILED(hr)) {
        return hr;
    }

    // OotB^tB^Otɒǉ
    hr = m_pGraph->AddFilter(m_pF, L"Grabber");
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (6) Null RenderertB^̍쐬
    //--------------------------------------
    hr = CoCreateInstance(CLSID_NullRenderer, NULL, CLSCTX_INPROC_SERVER,
                     IID_IBaseFilter, (void **)&m_pNull);
    if (FAILED(hr)) {
        return hr;
    }

    hr = m_pGraph->AddFilter(m_pNull, L"Renderer");
    if (FAILED(hr)) {
        return hr;
    }   

    //--------------------------------------
    // (7) tB^̐ڑ
    //--------------------------------------
    IPin *pSrcOut   = GetPin(m_pbf, PINDIR_OUTPUT);
    IPin *pSGrabIN  = GetPin(m_pF, PINDIR_INPUT);
    IPin *pSGrabOut = GetPin(m_pF, PINDIR_OUTPUT);
    IPin *pNullIN   = GetPin(m_pNull, PINDIR_INPUT);

    // \[XtB^TvOotB^̐ڑ
    hr = m_pGraph->Connect(pSrcOut, pSGrabIN);
    if (FAILED(hr)) {
        return hr;
    }

    // TvOotB^Null_̐ڑ
    hr = m_pGraph->Connect(pSGrabOut, pNullIN);
    if (FAILED(hr)) {
        return hr;
    }

    pSrcOut->Release();
    pSGrabIN->Release();
    pSGrabOut->Release();
    pNullIN->Release();

    //--------------------------------------
    // (8) Oõ[hK؂ɐݒ
    //--------------------------------------
    hr = m_pGrab->SetBufferSamples(TRUE);
    if (FAILED(hr)) {
        return hr;
    }
    hr = m_pGrab->SetOneShot(FALSE);
    if (FAILED(hr)) {
        return hr;
    }
    
    //--------------------------------------
    // (9) fBARg[쐬
    //--------------------------------------
    hr = m_pGraph->QueryInterface(IID_IMediaControl, (LPVOID *)&m_pMC);
    if (FAILED(hr)) {
        return hr;
    }
    hr = m_pGraph->QueryInterface(IID_IMediaEvent, (LPVOID *)&m_pEV);
    if (FAILED(hr)) {
        return hr;
    }

    //--------------------------------------
    // (10) 摜i[̈m
    //--------------------------------------
    AM_MEDIA_TYPE mt;
    // fBA^Cv擾
    hr = m_pGrab->GetConnectedMediaType(&mt);
    if (FAILED(hr))    {
        return hr;
    }
    m_imageSize = mt.lSampleSize;

    WaitForSingleObject(m_hMutex,INFINITE);
     m_pBuffer_Cur = (BYTE *)malloc(m_imageSize);
    ReleaseMutex(m_hMutex);
    if (m_pBuffer_Cur==NULL) {
      return S_FALSE;
    }
     m_pBuffer_Pre = (BYTE *)malloc(m_imageSize);
    if (m_pBuffer_Pre==NULL) {
      return S_FALSE;
    }

    m_pImage = (BYTE *)malloc(m_imageSize + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER));
    if (m_pImage==NULL) {
      return S_FALSE;
    }
    // t@Cwb_
    BITMAPFILEHEADER bfh;
    memset(&bfh, 0, sizeof(bfh));
    bfh.bfType = 'MB';
    bfh.bfSize = sizeof(bfh) + m_imageSize + sizeof(BITMAPINFOHEADER);
    bfh.bfOffBits = sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);

    VIDEOINFOHEADER *vih = (VIDEOINFOHEADER*)mt.pbFormat;
    // rbg}bvtH[}bg
    BITMAPINFOHEADER bih;
    memset(&bih, 0, sizeof(bih));
    bih.biSize = sizeof(bih);
    bih.biWidth = vih->bmiHeader.biWidth;
    bih.biHeight = vih->bmiHeader.biHeight;
    bih.biPlanes = 1;
    bih.biBitCount = 24;
    memcpy(m_pImage, &bfh, sizeof(bfh));
    memcpy(m_pImage + sizeof(bfh), &bih, sizeof(bih) );

    hr = m_pMC->Run();
    if (FAILED(hr)) {
        return hr;
    }

    m_bInitialize = TRUE;

    //--------------------------------------
    // (11) XibvVbg擾
    //--------------------------------------
	Sleep(1000);		// I܂1b҂
    Capture();
    return S_OK;
}

/** I
 *
 * e\[X̊JsD
 */ 
void CCameraManager::Finalize(){
    if (m_pF != NULL)
        m_pF->Release();
    if (m_pGrab != NULL)
        m_pGrab->Release();
    if (m_pbf != NULL)
        m_pbf->Release();
    if (m_pMC != NULL)
        m_pMC->Release();       
    if (m_pEV != NULL)
        m_pEV->Release();       
    if (m_pGraph != NULL)
        m_pGraph->Release();
    if (m_pCapture != NULL)
        m_pCapture->Release();
    if (m_pNull != NULL)
        m_pNull->Release();

    if (m_pBuffer_Cur != NULL)
        free(m_pBuffer_Cur);
    if (m_pBuffer_Pre != NULL)
        free(m_pBuffer_Pre);
    if (m_pImage != NULL)
        free(m_pImage);
    // COM̃[X
    CoUninitialize();

    CloseHandle(m_hMutex);
}

/** Lv`
 *
 * Î~̃Lv`sB
 *
 *  @retval HRESULT
 */ 
HRESULT CCameraManager::Capture(){
    HRESULT hr;

    if (!m_bInitialize) {
        return S_FALSE;
    }

    // 摜i[obt@̑ޔ
    WaitForSingleObject(m_hMutex,INFINITE);
    CopyMemory(m_pBuffer_Pre, m_pBuffer_Cur ,m_imageSize);

    // obt@TCY擾
    long work;
    hr = m_pGrab->GetCurrentBuffer(&work, NULL);
    if (FAILED(hr)) {
        return hr;
    }

    // obt@擾
    hr = m_pGrab->GetCurrentBuffer(&work, (long *)m_pBuffer_Cur);
    ReleaseMutex(m_hMutex);
    if (FAILED(hr)) {
        return hr;
    }
    return S_OK;
}

/** s擾
 *
 * s̎擾sB
 *
 *  @retval IPin*
 */ 
IPin* CCameraManager::GetPin(IBaseFilter *pFilter, PIN_DIRECTION PinDir){
    BOOL       bFound = FALSE;
    IEnumPins  *pEnum;
    IPin       *pPin;
    HRESULT    hr;

    hr = pFilter->EnumPins(&pEnum);
    if (FAILED(hr)) {
        return (IPin *)NULL;
    }

    while(pEnum->Next(1, &pPin, 0) == S_OK) {
        PIN_DIRECTION PinDirThis;
        pPin->QueryDirection(&PinDirThis); // Ŏw肵̃sȂbreak
        if (PinDir == PinDirThis) {
            bFound = TRUE;
            break;
        }
        pPin->Release();
    }
    pEnum->Release();
    return (bFound ? pPin : (IPin *)NULL);
}

/** 摜o
 *
 * 摜̍oB
 *
 *  @retval BOOL
 */ 
BOOL CCameraManager::IsDiffDetected(){
    double s = 0.0;
    WaitForSingleObject(m_hMutex,INFINITE);
    for (int i = 0; i < m_imageSize; i++) {
        // Ƃ
        s = s +  fabs(m_pBuffer_Cur[i] - m_pBuffer_Pre[i]);
    }
    ReleaseMutex(m_hMutex);
    // s / TCY > m_threshold(臒l) ̏ꍇ̓A[
    return ( (s / m_imageSize) > m_threshold ? TRUE : FALSE );
    
}

/** 摜擾
 *
 * 摜t@C擾B
 *
 *  @retval BYTE*
 */ 
BYTE *CCameraManager::GetImage(long *lSize ){
    WaitForSingleObject(m_hMutex,INFINITE);
    *lSize = m_imageSize + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
    memcpy(m_pImage + sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER), m_pBuffer_Cur, sizeof(BYTE) * m_imageSize);
    ReleaseMutex(m_hMutex);

    return m_pImage;
}

/** 臒l擾
 *
 * 臒l擾B
 *
 *  @retval long
 */ 
long CCameraManager::GetThreshold(){
    return m_threshold;
}

/** 臒lݒ
 *
 * 臒lݒ肷B
 *
 */ 
void CCameraManager::SetThreshold( long threshold ){
    m_threshold = threshold;
}
