/** @file CaoProvController.h
 *
 *  @brief CCaoProvController ̐錾
 *
 *  @version	1.0
 *	@date		2003/8/8
 *	@author		DENSO WAVE
 *
 */

#ifndef __CAOPROVCONTROLLER_H_
#define __CAOPROVCONTROLLER_H_

#include "resource.h"       // C V{
#include "CAOPROVCP.h"
#include "CaoProvCommand.h"
#include "CaoProvVariable.h"
#include "CaoProvRobot.h"
#include "CaoProvFile.h"
#include "CaoProvTask.h"
#include "CaoProvExtension.h"
#include "CaoProvControllerImpl.h"
#include "MouseManager.h"

/**	CAOvoC_ControllerNX
 *
 *	fAC^[tF[XCOM̃NXDڍׂICaoProvControllerQƁD<br>
 *	CAOvoC_ɂCOMNCAgBCX^X쐬\ȃNXD<br>
 *  C^[tF[XICaoProvControllerImplNXŎĂD
 *
 */
class ATL_NO_VTABLE CCaoProvController : 
	public ICaoProvControllerImpl<CCaoProvController, CCaoProvExtension, CCaoProvFile, CCaoProvRobot, CCaoProvTask, CCaoProvVariable, CCaoProvCommand, CCaoProvMessage>
{
protected:
	HRESULT FinalInitialize();
	void FinalTerminate();

	HRESULT FinalConnect();
	HRESULT FinalDisconnect();
//	HRESULT FinalExecute(/*[in]*/ VARIANT Command, /*[out, retval]*/ VARIANT *pVal);

//	HRESULT FinalGetAttribute(/*[out, retval]*/ long *pVal);
//	HRESULT FinalGetHelp(/*[out, retval]*/ BSTR *pVal);
//	HRESULT FinalGetCommandNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetExtensionNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetFileNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetRobotNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetTaskNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetVariableNames(/*[in]*/ BSTR bstrOption, /*[out, retval]*/ VARIANT *pVal);
//	HRESULT FinalGetID(VARIANT *pVal);
//	HRESULT FinalPutID(VARIANT newpVal);

public:
#if CAOP_TIMER_INTERVAL > 0
	void OnTimer();
#endif

// ========== eВǉ֐͂ȉɋLqD==========

private:
// ========== eВǉ֐͂ȉɋLqD==========
    CMouseManager m_mouseManager;
};

#endif //__CAOPROVCONTROLLER_H_
