#include "stdafx.h"
#include "MouseManager.h"
CMouseManager::CMouseManager(){
}

CMouseManager::~CMouseManager(){
}

HRESULT CMouseManager::Initialize(){
    HRESULT hr;
    hr = DirectInputCreate(GetModuleHandle(NULL), DIRECTINPUT_VERSION, &m_lpdi, NULL);
    if (FAILED(hr)) {
        return FALSE;
    }
    hr = m_lpdi->CreateDevice(GUID_SysMouse, &m_lpdiMouse, NULL); 
    if (FAILED(hr)) {
        return FALSE;
    }
    hr = m_lpdiMouse->SetDataFormat(&c_dfDIMouse);
    if (FAILED(hr)) {
        return FALSE;
    }
    hr = m_lpdiMouse->Acquire();
    if (FAILED(hr)) {
        return FALSE;
    }
    return S_OK;
}

void CMouseManager::Finalize(){
    m_lpdiMouse->Unacquire();
    m_lpdiMouse->Release();
    m_lpdi->Release();
} 

void CMouseManager::GetLocation(VARIANT *pVal){
    DIMOUSESTATE state;
    SAFEARRAY* pSafeArray;
    SAFEARRAYBOUND bound = {7, 0};
    LONG* pArray;

    pSafeArray = SafeArrayCreate(VT_I4, 1, &bound);
    m_lpdiMouse->GetDeviceState(sizeof(DIMOUSESTATE), &state);  
    SafeArrayAccessData(pSafeArray, (void**)&pArray);
    pArray[0] = state.lX;
    pArray[1] = state.lY;
    pArray[2] = state.lZ;
    pArray[3] = (LONG)(state.rgbButtons[0] & 0x80);
    pArray[4] = (LONG)(state.rgbButtons[1] & 0x80);
    pArray[5] = (LONG)(state.rgbButtons[2] & 0x80);
    pArray[6] = (LONG)(state.rgbButtons[3] & 0x80);
    pVal->vt = VT_ARRAY | VT_I4; 
    pVal->parray = pSafeArray;
    SafeArrayUnaccessData(pSafeArray);
}
